%Chapter 7,  Fig 7.9
%Eric Dubois, updated 2018-12-13
%Plot the 1924 relative luminous efficiency curve for the MDSP monograph
% data files obtained from CVRL website
%Data files should be placed in a data directory on the MATLAB path.
clear all, close all;
%The curve is defined from 360 nm to 830 nm in steps of 1 nm.
vl = dlmread('vl1924e_1.txt',',');
figure;
plot(vl(:,1), vl(:,2),'k') 
xlabel('Wavelength (nm)');
ylabel('spectral luminous efficiency');
axis([370 730 0 1]);
set(gcf,'Color',[1 1 1]);
set(gca,'fontname','times')          %set the plot font to Times