%Chapter 7,  Fig 7.1
%Eric Dubois, updated 2018-12-12
%Plot various spectral densities to illustrate the concept
%Data files should be placed in a data directory on the MATLAB path.
close all; clear all;
%Ocean Optics LS1 Light Source
%
load LS1.txt
figure;

plot(LS1(:,1),LS1(:,2),'k')
xlabel('Wavelength (nm)');
ylabel('Relative power');
title('Ocean Optics LS1 Light Source');
set(gcf,'Color',[1 1 1]);
set(gca,'fontname','times')          %set the plot font to Times
%
%EIZO CRT monitor
%
load EIZO_Norm.txt
figure;
plot(EIZO_Norm(:,1),EIZO_Norm(:,2),'r',EIZO_Norm(:,1),EIZO_Norm(:,3),'g',...
    EIZO_Norm(:,1),EIZO_Norm(:,4),'b')
xlabel('Wavelength (nm)');
ylabel('Relative power');
title('EIZO CRT monitor');
set(gcf,'Color',[1 1 1]);
set(gca,'fontname','times')          %set the plot font to Times

%
%SyncMaster LCD monitor
%
load SyncMaster_Norm.txt
figure;

plot(SyncMaster_Norm(:,1),SyncMaster_Norm(:,2),'r',SyncMaster_Norm(:,1),SyncMaster_Norm(:,3),'g',...
    SyncMaster_Norm(:,1),SyncMaster_Norm(:,4),'b')
xlabel('Wavelength (nm)');
ylabel('Relative power');
title('SyncMaster LCD monitor');
set(gcf,'Color',[1 1 1]);
set(gca,'fontname','times')          %set the plot font to Times

%
% Helium Laser
%
figure;
plot([633 633], [0 .8],'k')
axis([400 700 0 1])
xlabel('Wavelength (nm)');
ylabel('Relative power');
title('Helium-Neon Laser at 633 nm');
set(gcf,'Color',[1 1 1]);
set(gca,'fontname','times')          %set the plot font to Times
%
%D65
%
load Illuminantd65.txt
figure;

plot(Illuminantd65(:,1),Illuminantd65(:,2),'k');
axis([300 800 0 125])
xlabel('Wavelength (nm)');
ylabel('Relative power');
title('Illuminant D65');
set(gcf,'Color',[1 1 1]);
set(gca,'fontname','times')          %set the plot font to Times

%
%LED white light
%
load Hyperikon_raw.txt
figure;

plot(Hyperikon_raw(:,1),Hyperikon_raw(:,2),'k');
axis([400 700 0 1])
xlabel('Wavelength (nm)');
ylabel('Relative power');
title('LED T8 white lamp');
set(gcf,'Color',[1 1 1]);
set(gca,'fontname','times')          %set the plot font to Times
